<?php
/***********************************************************
	Filename: app/admin/control/elder.php
	Note	: 老人管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class elder_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("elder");
		$this->load_model("shop");
		$this->load_model("admin");
	}

	function elder_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("elder:list","tpl");//查看权限
		//判断是否是系统管理员
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$condition = "s.status=1";
		$pageurl = $this->url("elder");
		$tplfile = $this->trans_lib->safe("tplfile");
		if($tplfile)
		{
			$pageurl .= "tplfile=".rawurlencode($tplfile)."&";
		}
		else
		{
			$tplfile = "list";
		}
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		$shopid = $this->trans_lib->int("shopid");
		if($shopid)
		{
			$condition .= " AND e.shopid='".$shopid."'";
			$pageurl .= "shopid=".$shopid."&";
		}
		if(!$admin_rs["if_system"])
		{
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist AS $key=>$value)
			{
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"])))
				{
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1)
			{
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
			unset($tmp_shoplist);
			if(!$shopid)
			{
				$condition .= " AND e.shopid IN(".sys_id_string($tmp_shopid).") ";
			}
		}
		$this->tpl->assign("shoplist",$shoplist);
		$this->tpl->assign("shopid",$shopid);
		//入住时间
		$etime = $this->trans_lib->safe("etime");
		if($etime)
		{
			$condition .= " AND FROM_UNIXTIME(e.etime,'%Y-%m-%d')='".$etime."' ";
			$pageurl .= "etime=".rawurlencode($etime)."&";
		}
		//生存状态
		$lifestatus = $this->trans_lib->safe("lifestatus");
		if($lifestatus)
		{
			$condition .= " AND e.lifestatus='".$lifestatus."' ";
			$pageurl .= "lifestatus=".rawurlencode($lifestatus)."&";
		}
		//关键字
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe("keywords");
		if($keywords && $keytype)
		{
			if($keytype == "e.cn_fullname")
			{
				$condition .= " AND (e.cn_fullname LIKE '%".$keywords."%' OR e.en_fullname LIKE '%".$keywords."%') ";
			}
			else
			{
				$condition .= " AND ".$keytype." LIKE '%".$keywords."%' ";
			}
			$this->tpl->assign("keytype",$keytype);
			$this->tpl->assign("keywords",$keywords);
			$pageurl .= "keywords=".rawurlencode($keywords)."&";
			$pageurl .= "keytype=".rawurlencode($keytype)."&";
		}
		$pageid = $this->trans_lib->int(SYS_PAGEID);
		$psize = defined("SYS_PSIZE") ? SYS_PSIZE : 30;
		$rslist = $this->elder_m->get_list($condition,$pageid,$psize);//取得产品列表
		$total = $this->elder_m->get_count($condition);
		$this->page_lib->set_psize($psize);
		$pagelist = $this->page_lib->page($pageurl,$total);
		if($pagelist)
		{
			$this->tpl->assign("pagelist",$pagelist);
		}
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->assign("popedom_print",sys_popedom("elder:print"));
		$this->tpl->display("elder/".$tplfile.".html");
	}

	//登记老人信息
	function set_f()
	{
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		if($admin_rs["if_system"])
		{
			$shoplist = $this->shop_m->get_all();//取得所有分类
			$this->tpl->assign("shoplist",$shoplist);
		}
		else
		{
			$shop_rs = $this->shop_m->get_one_from_admin($_SESSION["admin_name"]);
			if(!$shop_rs)
			{
				error("该管理员没有相关分院权限");
			}
			$shopid = $shop_rs["id"];
		}
		$id = $this->trans_lib->int("id");
		if($id)
		{
			sys_popedom("elder:modify","tpl");
			$this->tpl->assign("id",$id);
			$rs = $this->elder_m->get_one($id);
			if(!$admin_rs["if_system"])
			{
				if($rs["shopid"] != $shopid)
				{
					error("该管理员没有权限编辑此老人信息",$this->url("elder"));
				}
			}
		}
		else
		{
			//取得最大ID
			sys_popedom("elder:add","tpl");
			$next_id = $this->elder_m->get_next_id();
			$rs["num"] = str_pad($next_id,4,"0",STR_PAD_LEFT);
		}
		$this->tpl->assign("rs",$rs);
		$this->tpl->display("elder/set.html");
	}

	function setok_f()
	{
		$array = array();
		$id = $this->trans_lib->int("id");
		$id ? sys_popedom("elder:modify","tpl") : sys_popedom("elder:add","tpl");
		//判断是否有权限
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		if($admin_rs["if_system"])
		{
			$shopid = $this->trans_lib->int("shopid");
			if(!$shopid)
			{
				error("没有指定分院信息",$this->url("elder,set","id=".$id));
			}
		}
		else
		{
			$shop_rs = $this->shop_m->get_one_from_admin($_SESSION["admin_name"]);
			if(!$shop_rs)
			{
				error("该管理员没有相关分院权限");
			}
			$shopid = $shop_rs["id"];
		}
		$array["shopid"] = $shopid;
		$array["en_fullname"] = $this->trans_lib->safe("en_fullname");
		$array["cn_fullname"] = $this->trans_lib->safe("cn_fullname");
		if(!$array["en_fullname"] && !$array["cn_fullname"])
		{
			error("姓名不允许为空",$this->url("elder,set","id=".$id));
		}
		$array["num"] = $this->trans_lib->safe("num");
		$chk_num = $this->_chk_elder_num($array["num"],$shopid,$id);
		if($chk_num != "ok")
		{
			error($chk_num,$this->url("elder,set","id=".$id));
		}
		//性别
		$array["gender"] = $this->trans_lib->safe("gender");
		$array["age"] = $this->trans_lib->int("age");
		$array["birthday"] = $this->trans_lib->safe("birthday");
		$array["bed_number"] = $this->trans_lib->safe("bed_number");
		$array["lifestatus"] = $this->trans_lib->safe("lifestatus");
		$array["rent"] = $this->trans_lib->float("rent");
		$array["foregift"] = $this->trans_lib->float("foregift");
		$array["contact_person"] = $this->trans_lib->safe("contact_person");
		$array["tel_day"] = $this->trans_lib->safe("tel_day");
		$array["tel_night"] = $this->trans_lib->safe("tel_night");
		$array["note"] = $this->trans_lib->safe("note");
		$array["hkid"] = $this->trans_lib->safe("hkid");
		$array["if_pay"] = $this->trans_lib->checkbox("not_if_pay") ? 0 : 1;
		$array["status"] = 1;
		$array["diapers"] = $this->trans_lib->float("diapers");
		$array["fixed_charges"] = $this->trans_lib->float("fixed_charges");
		$array["fixed_charges_note"] = $this->trans_lib->safe("fixed_charges_note");
		$etime = $this->trans_lib->safe("etime");
		$backurl = $this->url("elder");
		if($etime)
		{
			$array["etime"] = strtotime($etime);
		}
		if($id)
		{
			$array["postdate"] = $this->system_time;
			$goback = $this->trans_lib->safe("goback");
			if($goback)
			{
				$backurl = $goback;
			}
			$_SESSION["set_elder_id"] = $id;
		}
		$array["address"] = $this->trans_lib->safe("address");
		$this->elder_m->save($array,$id);
		$a_e = $id ? "编辑" : "添加";
		error("老人信息".$a_e."成功！",$backurl);
	}

	function _chk_elder_num($num,$shopid=0,$id=0)
	{
		if(!$num)
		{
			return "编号不允许为空！";
		}
		if(!$shopid)
		{
			return "请选择分院！";
		}
		$rs = $this->elder_m->chk_num($num,$shopid,$id);
		if($rs)
		{
			return "编号已经存在！";
		}
		else
		{
			return "ok";
		}
	}

	//检测编号是否冲突
	function chknum_f()
	{
		$id = $this->trans_lib->int("id");
		$shopid = $this->trans_lib->int("shopid");
		$num = $this->trans_lib->safe("num");
		if(!$shopid)
		{
			$shop_rs = $this->shop_m->get_one_from_admin($_SESSION["admin_name"]);
			if(!$shop_rs)
			{
				exit("该管理员没有相关分院权限");
			}
			$shopid = $shop_rs["id"];
		}
		exit($this->_chk_elder_num($num,$shopid,$id));
	}

	function del_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("elder:del","ajax");
		$this->elder_m->del($id);
		exit("ok");
	}

	function taxis_f()
	{
		$id = $this->trans_lib->int("id");
		$taxis = $this->trans_lib->int("taxis");
		if(!$id)
		{
			exit("没有指定产品ID");
		}
		$array = array();
		$array["taxis"] = $taxis;
		$this->elder_m->save($array,$id);
		exit("ok");
	}

	function status_f()
	{
		$id = $this->trans_lib->int("id");
		$status = $this->trans_lib->int("status");
		if(!$id)
		{
			exit("没有指定产品ID");
		}
		$array = array();
		$array["status"] = $status;
		$this->elder_m->save($array,$id);
		exit("ok");
	}

	function print_f()
	{
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$condition = "1=1";
		if($admin_rs["if_system"])
		{
			$shoplist = $this->shop_m->get_all();//取得所有分类
			$this->tpl->assign("shoplist",$shoplist);
			$shopid = $this->trans_lib->int("shopid");
			if($shopid)
			{
				$condition .= " AND e.shopid='".$shopid."'";
			}
			$shop_rs = $this->shop_m->get_one($shopid);
			if(!$shop_rs)
			{
				exit("error");
			}
		}
		else
		{
			$shop_rs = $this->shop_m->get_one_from_admin($_SESSION["admin_name"]);
			if(!$shop_rs)
			{
				exit("error");
			}
			$shopid = $shop_rs["id"];
			$condition .= " AND e.shopid='".$shopid."'";
		}
		$this->tpl->assign("shopid",$shopid);
		$this->tpl->assign("shop_rs",$shop_rs);
		//入住时间
		$etime = $this->trans_lib->safe("etime");
		if($etime)
		{
			$condition .= " AND FROM_UNIXTIME(e.etime,'%Y-%m-%d')='".$etime."' ";
		}
		//生存状态
		$lifestatus = $this->trans_lib->safe("lifestatus");
		if($lifestatus)
		{
			$condition .= " AND e.lifestatus='".$lifestatus."' ";
		}
		//关键字
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe("keywords");
		if($keywords && $keytype)
		{
			if($keytype == "e.cn_fullname")
			{
				$condition .= " AND (e.cn_fullname LIKE '%".$keywords."%' OR e.en_fullname LIKE '%".$keywords."%') ";
			}
			else
			{
				$condition .= " AND ".$keytype." LIKE '%".$keywords."%' ";
			}
			$this->tpl->assign("keytype",$keytype);
			$this->tpl->assign("keywords",$keywords);
		}
		$total = $this->elder_m->get_count($condition);
		$rslist = $this->elder_m->get_list($condition,0,$total);//取得产品列表
		$this->tpl->assign("total",$total);
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("print/elder_list.html");
	}

	//登记老人信息
	function view_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			error("没有指定ID");
		}
		$this->tpl->assign("id",$id);
		$rs = $this->elder_m->get_one($id);
		$this->tpl->assign("rs",$rs);
		$this->tpl->display("elder/view.html");
	}

	function expense_f()
	{
		$this->load_model("products");
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			error("请选择老人信息");
		}
		$rs = $this->elder_m->get_one($id);
		$this->tpl->assign("rs",$rs);
		$expenselist = $this->elder_m->expense_all($id);
		$this->tpl->assign("expenselist",$expenselist);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("elder/products.html");
	}

	function expense_ok_f()
	{
		$this->load_model("products");
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			error("请选择老人信息");
		}
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$expenselist = $this->elder_m->expense_all($id);
		$keys = $expenselist ? array_keys($expenselist) : array();
		foreach($rslist AS $key=>$value)
		{
			$pronum = $this->trans_lib->float("proid_".$value["id"]);
			if($pronum>0.001)
			{
				$this->elder_m->expense_save($value["id"],$id,$pronum);
			}
			else
			{
				if($keys && count($keys)>0 && in_array($value["id"],$keys))
				{
					$this->elder_m->expense_del($value["id"],$id);
				}
			}
		}
		error('数据存储成功，请关闭窗口！&nbsp;<input type="button" value="关闭此窗口" onclick="parent.Layer.over();" />');
	}
}
?>